ara/server/urls.py
#  Copyright (c) 2019 Red Hat, Inc.
#
#  This file is part of ARA Records Ansible.
#
#  ARA is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  ARA is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with ARA.  If not, see <http://www.gnu.org/licenses/>.

import urllib.parse

import pbr.version
from django.contrib import admin
from django.urls import include, path
from rest_framework.response import Response
from rest_framework.views import APIView


# fmt: off
class APIIndex(APIView):
    def get(self, request):
        return Response({
            "kind": "ara",
            "version": pbr.version.VersionInfo("ara").release_string(),
            "api": list(map(lambda x: urllib.parse.urljoin(
                request.build_absolute_uri(), x),
                [
                    "v1/",
                ]))
        })


urlpatterns = [
    path("", include("ara.ui.urls")),
    path("api/", APIIndex.as_view(), name='api-index'),
    path("api/v1/", include("ara.api.urls")),
    path("admin/", admin.site.urls),
    path("healthcheck/", include("health_check.urls")),
]
# fmt: on

ara/ui/urls.py
from django.urls import path
from django.views.generic import TemplateView

from ara.ui import views

app_name = "ui"
urlpatterns = [
    path("", views.Index.as_view(), name="index"),
    path("hosts", views.HostIndex.as_view(), name="host_index"),
    path("robots.txt", TemplateView.as_view(template_name="robots.txt", content_type="text/plain")),
    path("playbooks/<int:pk>.html", views.Playbook.as_view(), name="playbook"),
    path("results/<int:pk>.html", views.Result.as_view(), name="result"),
    path("files/<int:pk>.html", views.File.as_view(), name="file"),
    path("hosts/<int:pk>.html", views.Host.as_view(), name="host"),
    path("records/<int:pk>.html", views.Record.as_view(), name="record"),
]

ara/ui/forms.py
#  Copyright (c) 2019 Red Hat, Inc.
#
#  This file is part of ARA Records Ansible.
#
#  ARA is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  ARA is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with ARA.  If not, see <http://www.gnu.org/licenses/>.

from django import forms

from ara.api import models


class PlaybookSearchForm(forms.Form):
    ansible_version = forms.CharField(label="Ansible version", max_length=255, required=False)
    controller = forms.CharField(label="Playbook controller", max_length=255, required=False)
    name = forms.CharField(label="Playbook name", max_length=255, required=False)
    path = forms.CharField(label="Playbook path", max_length=255, required=False)
    status = forms.MultipleChoiceField(
        widget=forms.CheckboxSelectMultiple, choices=models.Playbook.STATUS, required=False
    )
    label = forms.CharField(label="Playbook label", max_length=255, required=False)
    started_after = forms.DateField(label="Started after", required=False)
    order = forms.CharField(label="Order", max_length=255, required=False)


class ResultSearchForm(forms.Form):
    host = forms.CharField(label="Host id", max_length=10, required=False)
    task = forms.CharField(label="Task id", max_length=10, required=False)
    changed = forms.BooleanField(label="Changed", required=False)

    status = forms.MultipleChoiceField(
        widget=forms.CheckboxSelectMultiple, choices=models.Result.STATUS, required=False
    )


class HostSearchForm(forms.Form):
    name = forms.CharField(label="Host name", max_length=255, required=False)
    latest = forms.BooleanField(label="latest", required=False)
    changed__gt = forms.IntegerField(label="changed", required=False)
    failed__gt = forms.IntegerField(label="failed", required=False)
    ok__gt = forms.IntegerField(label="ok", required=False)
    skipped__gt = forms.IntegerField(label="skipped", required=False)
    unreachable__gt = forms.IntegerField(label="unreachable", required=False)

ara/ui/views.py
import codecs

from rest_framework import generics
from rest_framework.renderers import TemplateHTMLRenderer
from rest_framework.response import Response

from ara.api import filters, models, serializers
from ara.ui import forms
from ara.ui.pagination import LimitOffsetPaginationWithLinks


class Index(generics.ListAPIView):
    """
    Returns a list of playbook summaries
    """

    queryset = models.Playbook.objects.all()
    filterset_class = filters.PlaybookFilter
    renderer_classes = [TemplateHTMLRenderer]
    pagination_class = LimitOffsetPaginationWithLinks
    template_name = "index.html"

    def get(self, request, *args, **kwargs):
        query = self.filter_queryset(self.queryset.all().order_by("-id"))
        page = self.paginate_queryset(query)
        if page is not None:
            serializer = serializers.ListPlaybookSerializer(page, many=True)
        else:
            serializer = serializers.ListPlaybookSerializer(query, many=True)
        response = self.get_paginated_response(serializer.data)

        if self.paginator.count > (self.paginator.offset + self.paginator.limit):
            max_current = self.paginator.offset + self.paginator.limit
        else:
            max_current = self.paginator.count
        current_page_results = "%s-%s" % (self.paginator.offset + 1, max_current)

        # We need to expand the search card if there is a search query, not considering pagination args
        search_args = [arg for arg in request.GET.keys() if arg not in ["limit", "offset"]]
        expand_search = True if search_args else False

        search_form = forms.PlaybookSearchForm(request.GET)

        # fmt: off
        return Response(dict(
            current_page_results=current_page_results,
            data=response.data,
            expand_search=expand_search,
            page="index",
            search_form=search_form,
            static_generation=False
        ))
        # fmt: on


class HostIndex(generics.RetrieveAPIView):
    """
    Returns the latest playbook result for each host (or all playbook results for every hosts)
    """

    renderer_classes = [TemplateHTMLRenderer]
    pagination_class = LimitOffsetPaginationWithLinks
    template_name = "host_index.html"

    def get(self, request, *args, **kwargs):
        search_form = forms.HostSearchForm(request.GET)

        # Sort by updated by default so we have the most recently updated at the top
        order = "-updated"
        if "order" in request.GET:
            order = request.GET["order"]

        # Default is LatestHost (by not requiring "?latest=true") but accept false to
        # return all hosts
        if "latest" in request.GET and request.GET["latest"] == "false":
            queryset = models.Host.objects.all()
            serializer_type = "DetailedHostSerializer"
            filter_type = "HostFilter"
            # TODO: Is there a cleaner way ? Doing this logic in the template seemed complicated.
            checkbox_status = "checked"
            api_link_url = "host-list"
        else:
            queryset = models.LatestHost.objects.all()
            serializer_type = "DetailedLatestHostSerializer"
            filter_type = "LatestHostFilter"
            checkbox_status = ""
            api_link_url = "latesthost-list"

            # Ordering on LatestHost should be applied to the nested host object
            if order.startswith("-"):
                order = "-host__%s" % order[1:]
            else:
                order = "host__%s" % order

            if "updated_after" in request.GET:
                # request.GET is immutable by default, copy it to set host__updated_after instead
                request.GET = request.GET.copy()
                request.GET["host__updated_after"] = request.GET["updated_after"]
                del request.GET["updated_after"]

        query = getattr(filters, filter_type)(request.GET, queryset=queryset)
        page = self.paginate_queryset(query.qs.all().order_by(order))
        if page is not None:
            serializer = getattr(serializers, serializer_type)(page, many=True)
        else:
            serializer = getattr(serializers, serializer_type)(query, many=True)
        response = self.get_paginated_response(serializer.data)

        if self.paginator.count > (self.paginator.offset + self.paginator.limit):
            max_current = self.paginator.offset + self.paginator.limit
        else:
            max_current = self.paginator.count
        current_page_results = "%s-%s" % (self.paginator.offset + 1, max_current)

        # We need to expand the search card if there is a search query, not considering pagination args
        search_args = [arg for arg in request.GET.keys() if arg not in ["limit", "offset"]]
        expand_search = True if search_args else False

        # fmt: off
        return Response(dict(
            api_link_url=api_link_url,
            checkbox_status=checkbox_status,
            current_page_results=current_page_results,
            data=response.data,
            expand_search=expand_search,
            page="host_index",
            search_form=search_form,
            static_generation=False,
        ))
        # fmt: on


class Playbook(generics.RetrieveAPIView):
    """
    Returns a page for a detailed view of a playbook
    """

    queryset = models.Playbook.objects.all()
    renderer_classes = [TemplateHTMLRenderer]
    pagination_class = LimitOffsetPaginationWithLinks
    template_name = "playbook.html"

    def get(self, request, *args, **kwargs):
        playbook = serializers.DetailedPlaybookSerializer(self.get_object())
        hosts = serializers.ListHostSerializer(
            models.Host.objects.filter(playbook=playbook.data["id"]).order_by("name").all(), many=True
        )
        files = serializers.ListFileSerializer(
            models.File.objects.filter(playbook=playbook.data["id"]).all(), many=True
        )
        records = serializers.ListRecordSerializer(
            models.Record.objects.filter(playbook=playbook.data["id"]).all(), many=True
        )

        order = "-started"
        if "order" in request.GET:
            order = request.GET["order"]
        result_queryset = models.Result.objects.filter(playbook=playbook.data["id"]).order_by(order).all()
        result_filter = filters.ResultFilter(request.GET, queryset=result_queryset)

        page = self.paginate_queryset(result_filter.qs)
        if page is not None:
            serializer = serializers.ListResultSerializer(page, many=True)
        else:
            serializer = serializers.ListResultSerializer(result_filter, many=True)

        # TODO: We should have a serializer that takes care of this automatically instead of backfilling "manually"
        for result in serializer.data:
            task = models.Task.objects.get(pk=result["task"])
            result["task"] = serializers.SimpleTaskSerializer(task).data
            host = models.Host.objects.get(pk=result["host"])
            result["host"] = serializers.SimpleHostSerializer(host).data
            if result["delegated_to"]:
                delegated_to = [models.Host.objects.get(pk=delegated) for delegated in result["delegated_to"]]
                result["delegated_to"] = serializers.SimpleHostSerializer(delegated_to, many=True).data
        paginated_results = self.get_paginated_response(serializer.data)

        if self.paginator.count > (self.paginator.offset + self.paginator.limit):
            max_current = self.paginator.offset + self.paginator.limit
        else:
            max_current = self.paginator.count
        current_page_results = "%s-%s" % (self.paginator.offset + 1, max_current)

        # We need to expand the search card if there is a search query, not considering pagination args
        search_args = [arg for arg in request.GET.keys() if arg not in ["limit", "offset"]]
        expand_search = True if search_args else False

        search_form = forms.ResultSearchForm(request.GET)

        # fmt: off
        return Response(dict(
            current_page_results=current_page_results,
            expand_search=expand_search,
            files=files.data,
            hosts=hosts.data,
            page="playbook",
            playbook=playbook.data,
            records=records.data,
            results=paginated_results.data,
            search_form=search_form,
            static_generation=False,
        ))
        # fmt: on


class Host(generics.RetrieveAPIView):
    """
    Returns a page for a detailed view of a host
    """

    queryset = models.Host.objects.all()
    renderer_classes = [TemplateHTMLRenderer]
    template_name = "host.html"

    def get(self, request, *args, **kwargs):
        host = self.get_object()
        host_serializer = serializers.DetailedHostSerializer(host)

        order = "-started"
        if "order" in request.GET:
            order = request.GET["order"]
        result_queryset = models.Result.objects.filter(host=host_serializer.data["id"]).order_by(order).all()
        result_filter = filters.ResultFilter(request.GET, queryset=result_queryset)

        page = self.paginate_queryset(result_filter.qs)
        if page is not None:
            result_serializer = serializers.ListResultSerializer(page, many=True)
        else:
            result_serializer = serializers.ListResultSerializer(result_filter, many=True)

        # TODO: We should have a serializer that takes care of this automatically instead of backfilling "manually"
        for result in result_serializer.data:
            task = models.Task.objects.get(pk=result["task"])
            result["task"] = serializers.SimpleTaskSerializer(task).data
            if result["delegated_to"]:
                delegated_to = [models.Host.objects.get(pk=delegated) for delegated in result["delegated_to"]]
                result["delegated_to"] = serializers.SimpleHostSerializer(delegated_to, many=True).data

ara/ui/templates/partials/host_index_row.html
{% load datetime_formatting %}
{% load static_url %}
<tr>
  <td class="text-center">
    {% include "partials/playbook_status_icon.html" with status=host.playbook.status %}
  </td>
  <td class="text-center">
    {% url 'ui:host' host.id as host_url %}
    <a role="button" class="btn btn-outline-primary btn-link btn-sm" href="{% static_url host_url %}">
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-box-arrow-up-right" viewBox="0 0 16 16">
      <path fill-rule="evenodd" d="M8.636 3.5a.5.5 0 0 0-.5-.5H1.5A1.5 1.5 0 0 0 0 4.5v10A1.5 1.5 0 0 0 1.5 16h10a1.5 1.5 0 0 0 1.5-1.5V7.864a.5.5 0 0 0-1 0V14.5a.5.5 0 0 1-.5.5h-10a.5.5 0 0 1-.5-.5v-10a.5.5 0 0 1 .5-.5h6.636a.5.5 0 0 0 .5-.5z"></path>
      <path fill-rule="evenodd" d="M16 .5a.5.5 0 0 0-.5-.5h-5a.5.5 0 0 0 0 1h3.793L6.146 9.146a.5.5 0 1 0 .708.708L15 1.707V5.5a.5.5 0 0 0 1 0v-5z"></path>
    </svg>
    </a>
  </td>
  <td class="text-nowrap">{{ host.updated | format_date }}</td>
  <td class="text-nowrap">{{ host.playbook.duration | format_duration }}</td>
  <td>
    <a {% if not static_generation %}href="{% url 'ui:host_index' %}?name={{ host.name }}&latest=false" title="Search results for {{ host.name }}"{% endif %}>
      {{ host.name }}
    </a>
  </td>
  <td>
    {% if host.ok %}
    <a class="badge badge-pill badge-success ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=ok#results" title="Search ok results for {{ host.name }}"{% endif %}>
      {{ host.ok }} OK
    </a>
    {% endif %}
    {% if host.changed %}
    <a class="badge badge-pill badge-warning ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?changed=True#results" title="Search changed results for {{ host.name }}"{% endif %}>
      {{ host.changed }} CHANGED
    </a>
    {% endif %}
    {% if host.failed %}
    <a class="badge badge-pill badge-danger ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=failed#results" title="Search failed results for {{ host.name }}"{% endif %}>
      {{ host.failed }} FAILED
    </a>
    {% endif %}
    {% if host.unreachable %}
    <a class="badge badge-pill badge-danger ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=unreachable#results" title="Search unreachable results for {{ host.name }}"{% endif %}>
      {{ host.unreachable }} UNREACHABLE
    </a>
    {% endif %}
    {% if host.skipped %}
    <a class="badge badge-pill badge-info ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=skipped#results" title="Search skipped results for {{ host.name }}"{% endif %}>
      {{ host.skipped }} SKIPPED
    </a>
    {% endif %}
  </td>
  <td>{% include "partials/host_facts_snippets.html" with host=host %}</td>
</tr>

ara/ui/templates/partials/host_results.html
{% load datetime_formatting %}
{% load static_url %}
<div class="accordion" id="results">
  <div class="card">
    <div class="card-header" id="results_card">
      <button class="btn btn-lg" style="font-size:1.2em;" type="button" data-toggle="collapse" data-target="#collapse_results" aria-expanded="true" aria-controls="collapse_results">
        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-bar-chart-steps" viewBox="0 0 16 16">
          <path d="M.5 0a.5.5 0 0 1 .5.5v15a.5.5 0 0 1-1 0V.5A.5.5 0 0 1 .5 0zM2 1.5a.5.5 0 0 1 .5-.5h4a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-4a.5.5 0 0 1-.5-.5v-1zm2 4a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-7a.5.5 0 0 1-.5-.5v-1zm2 4a.5.5 0 0 1 .5-.5h6a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-6a.5.5 0 0 1-.5-.5v-1zm2 4a.5.5 0 0 1 .5-.5h7a.5.5 0 0 1 .5.5v1a.5.5 0 0 1-.5.5h-7a.5.5 0 0 1-.5-.5v-1z"/>
        </svg>
        Task results: {{ host.name }}
      </button>
        {% if host.ok %}
        <a class="badge badge-pill badge-success ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=ok#results" title="Search ok results for {{ host.name }}"{% endif %}>
            {{ host.ok }} OK
        </a>
        {% endif %}
        {% if host.changed %}
        <a class="badge badge-pill badge-warning ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?changed=True#results" title="Search changed results for {{ host.name }}"{% endif %}>
            {{ host.changed }} CHANGED
        </a>
        {% endif %}
        {% if host.failed %}
        <a class="badge badge-pill badge-danger ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=failed#results" title="Search failed results for {{ host.name }}"{% endif %}>
            {{ host.failed }} FAILED
        </a>
        {% endif %}
        {% if host.unreachable %}
        <a class="badge badge-pill badge-danger ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=unreachable#results" title="Search unreachable results for {{ host.name }}"{% endif %}>
            {{ host.unreachable }} UNREACHABLE
        </a>
        {% endif %}
        {% if host.skipped %}
        <a class="badge badge-pill badge-info ara-result-status-badge" {% if not static_generation %}href="{% url 'ui:host' host.id %}?status=skipped#results" title="Search skipped results for {{ host.name }}"{% endif %}>
            {{ host.skipped }} SKIPPED
        </a>
        {% endif %}
    </div>
    {% if not static_generation %}
      <form method="get" action="{% url 'ui:host' host.id %}#results">
    {% endif %}
    <div id="collapse_results" class="collapse show" aria-labelledby="results_card" data-parent="#results">
      <div class="card-body">
        {% if not static_generation %}
          <div class="col-xl-6 offset-xl-3">
            <div class="accordion" id="search_accordion">
              <div class="card">
                <div class="card-header" id="search_form">
                  <button class="btn btn-link btn-lg" type="button" data-toggle="collapse" data-target="#collapse_search" aria-expanded="{{ expand_search }}" aria-controls="collapse_search">
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-search" viewBox="0 0 16 16">
                      <path d="M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001c.03.04.062.078.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1.007 1.007 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0z"></path>
                    </svg>
                    Search and filter
                  </button>
                </div>
                <div id="collapse_search" class="{% if expand_search %}show{% endif %} collapse" aria-labelledby="search_form" data-parent="#search_accordion">
                  <div class="card-body">
                    <div class="form-row">
                      <div class="form-group col-xl-4">
                        <label for="task" {% if request.GET.task %}style="font-weight:bold;"{% endif %}>Task ID</label>
                        <input type="text" class="form-control" id="task" name="task" placeholder="ex: 1234" value="{{ search_form.task.value | default_if_none:'' }}">
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group col-xl-12">
                        <label class="align-middle" for="status" {% if request.GET.status %}style="font-weight:bold;"{% endif %}>Status: </label>
                        {% for value, text in search_form.status.field.choices %}
                          {% if value != "unknown" %}
                            <div class="form-check form-check-inline">
                              <input class="form-check-input" type="checkbox" id="{{ value }}" value="{{ value }}" name="status" {% if value in search_form.status.data %}checked{% endif %}/>
                              <label class="form-check-label" for="{{ value }}">
                                {% include "partials/result_status_icon.html" with status=value %}
                              </label>
                            </div>
                          {% endif %}
                        {% endfor %}
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group col-xl-12">
                        <label class="align-middle" for="changed" {% if request.GET.changed %}style="font-weight:bold;"{% endif %}>Changed: </label>
                        <div class="form-check form-check-inline">
                          <input class="form-check-input" type="checkbox" id="changed" value="true" name="changed" {% if search_form.changed.value %}checked{% endif %}/>
                          <label class="form-check-label" for="changed">
                            <span class="badge badge-pill badge-warning" style="font-size:0.9em;" title="Search changed results">
                              CHANGED
                            </span>
                          </label>
                        </div>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group col-xl-12">
                        <button type="submit" class="btn btn-primary">
                          Submit
                        </button>
                      </div>
                    </div>
                    <div class="form-row">
                      <div class="form-group col-xl-12">
                        {% if request.GET %}
                          <a class="btn btn-outline-danger" href="{% url 'ui:host' host.id %}#results" role="button">Reset</a>
                        {% endif %}
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        {% endif %}
        {% if results.count %}
          {% if not static_generation %}
            {% include "partials/pagination.html" with data=results %}
          {% endif %}
          <div class="table-responsive">
            <table class="table table-sm table-hover" id="results">
              <thead>
                <tr style="height:50px;">
                  <th class="text-center">Details</th>
                  <th class="text-center">Status</th>
                  <th>Host</th>
                  <th>Action</th>
                  <th>Task</th>
                  <th>{% include "partials/sort_by_duration.html" %}</th>
                  <th>Date {% include "partials/sort_by_date.html" with arg="started" %}</th>
                </tr>
              </thead>
              <tbody>
              {% for result in results.results %}
                {% url 'ui:playbook' playbook.id as playbook_url %}
                {% url 'ui:result' result.id as result_url %}
                <tr>
                  <td class="text-center">
                    <a role="button" class="btn btn-outline-primary btn-link btn-sm" href="{% static_url result_url %}">
                      <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-box-arrow-up-right" viewBox="0 0 16 16">
                        <path fill-rule="evenodd" d="M8.636 3.5a.5.5 0 0 0-.5-.5H1.5A1.5 1.5 0 0 0 0 4.5v10A1.5 1.5 0 0 0 1.5 16h10a1.5 1.5 0 0 0 1.5-1.5V7.864a.5.5 0 0 0-1 0V14.5a.5.5 0 0 1-.5.5h-10a.5.5 0 0 1-.5-.5v-10a.5.5 0 0 1 .5-.5h6.636a.5.5 0 0 0 .5-.5z"></path>
                        <path fill-rule="evenodd" d="M16 .5a.5.5 0 0 0-.5-.5h-5a.5.5 0 0 0 0 1h3.793L6.146 9.146a.5.5 0 1 0 .708.708L15 1.707V5.5a.5.5 0 0 0 1 0v-5z"></path>
                      </svg>
                    </a>
                  </td>
                  <td class="text-center">
                    {% if not static_generation %}
                      {% url 'ui:host' host.id as host_url %}
                      {% include "partials/result_status_icon.html" with status=result.status search_url=host_url %}
                    {% else %}
                      {% include "partials/result_status_icon.html" with status=result.status %}
                    {% endif %}
                  </td>
                  <td>
                    {{ host.name }}
                    {% if result.delegated_to %}
                      <span title="task delegated to {% for delegated in result.delegated_to %}{{ delegated.name }}{% if not forloop.last %}, {% endif %}{% endfor %}">
                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-info-circle" viewBox="0 0 16 16">
                          <path d="M8 15A7 7 0 1 1 8 1a7 7 0 0 1 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
                          <path d="m8.93 6.588-2.29.287-.082.38.45.083c.294.07.352.176.288.469l-.738 3.468c-.194.897.105 1.319.808 1.319.545 0 1.178-.252 1.465-.598l.088-.416c-.2.176-.492.246-.686.246-.275 0-.375-.193-.304-.533L8.93 6.588zM9 4.5a1 1 0 1 1-2 0 1 1 0 0 1 2 0z"/>
                        </svg>
                      </span>
                    {% endif %}
                  </td>
                  <td nowrap>
                    {% if not static_generation %}
                      {% url 'ui:file' result.task.file as file_url %}
                      <a href="{% static_url file_url %}?#line-{{ result.task.lineno }}">{{ result.task.action }}</a>
                    {% else %}
                      {{ result.task.action }}
                    {% endif %}
                  </td>
                  <td>
                    {% if not static_generation %}
                      <a href="{% static_url playbook_url %}?task={{ result.task.id }}#results">{{ result.task.name }}</a>
                    {% else %}
                      {{ result.task.name }}
                    {% endif %}
                  </td>
                  <td>{{ result.duration | format_duration }}</td>
                  <td>{{ result.started | format_date }}</td>
                </tr>
              {% endfor %}
              </tbody>
            </table>
          </div>
        {% else %}
          <br/>
          <div>
            {% if not request.GET %}
              <h2>No recorded results found for this host.</h2>
              <h3>The playbook might have been interrupted or is in progress.</h3>
            {% else %}
              <h3>No results found matching your query: try <a href="{% url 'ui:host' host.id %}#results">clearing search filters</a>.</h3>
            {% endif %}
          </div>
        {% endif %}
      </div>
    </div>
    </form>
  </div>
</div>
<br/>

ara/ui/templates/partials/playbook_status_icon.html
<a
  {% if not static_generation %}href="{% url 'ui:index' %}?status={{ status }}"{% endif %}
  class="btn btn-sm {% if status == 'completed' %}btn-success{% elif status == 'failed' %}btn-danger{% elif status == 'running' %}btn-info{% else %}btn-warning{% endif %}"
>
  {% include "partials/status_icon.html" with status=status %}
</a>